// ui.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "iCaT.h"
#include "ui.h"
#include <iostream>

#include "SVIUSB20.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

using namespace std;

/////////////////////////////////////////////////////////////////////////////
// Cui

Cui::Cui()
{
	m_OpenFlag = FALSE;
	m_ulRcvLen = 0;
	m_lpRcvData = NULL;
	SVIUSB20_Init();
}

Cui::~Cui()
{
	m_OpenFlag = FALSE;
	if(m_lpRcvData){
		GlobalUnlock(m_hRcvMem);
		GlobalFree(m_hRcvMem);
	}

}

BEGIN_MESSAGE_MAP(Cui, CWnd)
	//{{AFX_MSG_MAP(Cui)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Cui bZ[W nh

DWORD sdk_open()
{
	CString strMenu;
	DWORD dwRet;
	char cBuf[32];
	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_REC)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_2);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}else{
		strMenu.LoadString(IDS_ERRMSG_0);
		cout << (LPCTSTR)strMenu << endl;
	}
	return 0;
}

DWORD sdk_close()
{
	CString strMenu;
	DWORD dwRet;
	char cBuf[32];
	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_REC)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_3);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}else{
		strMenu.LoadString(IDS_ERRMSG_0);
		cout << (LPCTSTR)strMenu << endl;
	}
	return 0;
}

void sdk_busreset()
{
	DWORD dwRet;
	CString strMenu;
	char cBuf[32];

	dwRet = SVIUSB20_BusReset();
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}
}

void sdk_devicereset()
{
	DWORD dwRet;
	CString strMenu;
	char cBuf[32];

	dwRet = SVIUSB20_DeviceReset();
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}
}

void sdk_getstatus()
{
	CString strMenu;
	char cBuf[32];
	DWORD dwRet;
	GET_STATUS GetStatus;

	// Xe[^X擾s܂
	dwRet = SVIUSB20_GetStatus(&GetStatus);
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}
	sprintf(cBuf,"ulBasicStatus : %08X",GetStatus.ulBasicStatus);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulHWVersion : %08X",GetStatus.ulHWVersion);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulFWVersion : %08X",GetStatus.ulFWVersion);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulOPStatus : %08X",GetStatus.ulOPStatus);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulStartupStatus : %08X",GetStatus.ulStartupStatus);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulOrgSizeW : %08X",GetStatus.ulOrgSizeW);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulOrgSizeH : %08X",GetStatus.ulOrgSizeH);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulCutout_x : %08X",GetStatus.ulCutout_x);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulCutout_y : %08X",GetStatus.ulCutout_y);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulCutSizeW : %08X",GetStatus.ulCutSizeW);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulCutSizeH : %08X",GetStatus.ulCutSizeH);
	cout << (LPCTSTR)cBuf << endl;
	sprintf(cBuf,"ulCamStatus : %08X",GetStatus.ulCamStatus);
	cout << (LPCTSTR)cBuf << endl;
}

void Cui::sdk_setparam()
{
	CString strMenu;
	char cBuf[32];
	DWORD dwRet;
	SET_PARAM SetParam;

	// foCXhCoI[v
	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_2);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}

	// ȉ̃p[^̗L(1)/(0)w肷
	//	SVIUSB20_SETPARAM_BIT0 : \
	//	SVIUSB20_SETPARAM_BIT1 : JdXCb`
	//	SVIUSB20_SETPARAM_BIT2 : I2CXs[h
	//	SVIUSB20_SETPARAM_BIT3 : \
	//	SVIUSB20_SETPARAM_BIT4 : \
	//	SVIUSB20_SETPARAM_BIT5 : VSYNCfAT[gtO
	//	SVIUSB20_SETPARAM_BIT6 : j^O[h
	//@wORZqgp

	strMenu.LoadString(IDS_MENU_SPARAM_1);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&SetParam.ulParamBitFlag);

	// JdXCb`i0:OFFA1:ONj
	strMenu.LoadString(IDS_MENU_SPARAM_3);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&SetParam.ulCamPower);

	// I2CXs[hi0:400KbpsA1:200KbpsA2:100Kbpsj
	strMenu.LoadString(IDS_MENU_SPARAM_4);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&SetParam.ulI2CSpeed);

	// VSYNCfAT[gtOi1:No wait deasert flagA0:Wait deasert flagj
	strMenu.LoadString(IDS_MENU_SPARAM_5);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&SetParam.ulVsyncFlag);

	// j^O[hi0:ޯ̧A1:ݸޯ̧j
	strMenu.LoadString(IDS_MENU_SPARAM_2);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&SetParam.ulMonMode);

	// 捞n[hEFAɃn[hEFAݒʒm܂
	dwRet = SVIUSB20_SetParam(&SetParam);
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}

	// foCXhCoN[Y
	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_3);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}
}

void sdk_getstatus2()
{
	CString strMenu;
	char cBuf[32];
	DWORD dwRet;
	ULONG ulStatus;

	// {Xe[^X擾܂
	dwRet = SVIUSB20_GetStatus2(&ulStatus);
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}
	sprintf(cBuf,"ulStatus : %08X",ulStatus);
	cout << (LPCTSTR)cBuf << endl;
}

void Cui::yuv2rgb(PBM pbmHead,LPVOID lpvData,ULONG ulLen, CFile *mFile)
{
	PUCHAR	pcPtr,pcWrt;
	DWORD	w,h;
	UCHAR	u0,v0,y0,y1,u2,v2;
	double	r0,g0,b0,r1,g1,b1;
	int i,j,k;

	pcPtr = (PUCHAR)lpvData;
	w = pbmHead->biWidth;
	h = pbmHead->biHeight;
	pcWrt = new BYTE[w*3];

	for(j=0;j<h;j++){
		for(i=k=0;i<w;k+=6,i+=2,pcPtr+=4){
			u0	= *(pcPtr+0);
			y0	= *(pcPtr+1);
			v0	= *(pcPtr+2);
			y1	= *(pcPtr+3);
			u2	= *(pcPtr+4);
			v2	= *(pcPtr+6);
			r0	= (double)y0 + (1.402 * (double)(v0 - 128));
			g0	= (double)y0 - (0.344 * (double)(u0 - 128)) - (0.714 * (double)(v0 - 128));
			b0	= (double)y0 + (1.772 * (double)(u0 - 128));
			r1	= (double)y1 + (1.402 * (double)((v0 + v2) / 2 - 128));
			g1	= (double)y1 - (0.344 * (double)((u0 + u2) / 2 - 128)) - (0.714 * (double)((v0 + v2) / 2 - 128));
			b1	= (double)y1 + (1.772 * (double)((u0 + u2) / 2 - 128));
			*(pcWrt+k+0) = (UCHAR)b0;
			*(pcWrt+k+1) = (UCHAR)g0;
			*(pcWrt+k+2) = (UCHAR)r0;
			*(pcWrt+k+3) = (UCHAR)b1;
			*(pcWrt+k+4) = (UCHAR)g1;
			*(pcWrt+k+5) = (UCHAR)r1;
		}
		mFile->Write( pcWrt, w*3 );
	}
	delete [] pcWrt;
}


 void Cui::sdk_mon()
 {
 	CString strMenu;
 	char cBuf[32];
 	DWORD dwRet,dwFrameCnt;
 	MONITOR_PARAM MonParam;
 	MON_HEADER MonHeader;
 	ULONG ulRetRcvLen;
 	BOOL bFlag=FALSE;
 	int j;
 	ULONG ulStatus;
 	ULONG ulFCnt=0;
	GET_STATUS GetStatus;
 
 	// foCXhCoI[v
 	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_REC)) != SVIUSB20_RET_NORMAL) {
 		strMenu.LoadString(IDS_ERRMSG_2);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 		return;
 	}

 	// ڑ`FbN
	for(j=0;j<3;j++){

		// SVI{[hZbg
 		if((dwRet=SVIUSB20_DeviceReset()) != SVIUSB20_RET_NORMAL) {
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
			goto mon_close;
		}

		// Xe[^X擾s܂
 		if((dwRet=SVIUSB20_GetStatus(&GetStatus)) != SVIUSB20_RET_NORMAL) {
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
			goto mon_close;
		}
		sprintf(cBuf,"ulBasicStatus : %08X",GetStatus.ulBasicStatus);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulHWVersion : %08X",GetStatus.ulHWVersion);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulFWVersion : %08X",GetStatus.ulFWVersion);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulOPStatus : %08X",GetStatus.ulOPStatus);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulStartupStatus : %08X",GetStatus.ulStartupStatus);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulOrgSizeW : %08X",GetStatus.ulOrgSizeW);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulOrgSizeH : %08X",GetStatus.ulOrgSizeH);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutout_x : %08X",GetStatus.ulCutout_x);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutout_y : %08X",GetStatus.ulCutout_y);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutSizeW : %08X",GetStatus.ulCutSizeW);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutSizeH : %08X",GetStatus.ulCutSizeH);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCamStatus : %08X",GetStatus.ulCamStatus);
		cout << (LPCTSTR)cBuf << endl;

		if( GetStatus.ulBasicStatus == SVI_STS_SUCCESS ) break;
		if( j == 2) goto mon_close;
	}
	
 	// p[^̓
 	strMenu.LoadString(IDS_MENU_MPARAM_1);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%d",&MonParam.ulCutout_x);
 
 	strMenu.LoadString(IDS_MENU_MPARAM_2);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%d",&MonParam.ulCutout_y);
 
 	strMenu.LoadString(IDS_MENU_MPARAM_3);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%d",&MonParam.ulCutout_w);
 
 	strMenu.LoadString(IDS_MENU_MPARAM_4);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%d",&MonParam.ulCutout_h);
 
 	strMenu.LoadString(IDS_MENU_MPARAM_5);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%d",&dwFrameCnt);
 
 	// j^OX^[gʒm܂
 	dwRet = SVIUSB20_MonStart(&MonParam);
 	if(dwRet != SVIUSB20_RET_NORMAL){
 		strMenu.LoadString(IDS_ERRMSG_1);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 		return;
 	}
 
 	// wt[M
 	for(;dwFrameCnt;dwFrameCnt--){
 
 		sprintf(cBuf,"F:x%08X",ulFCnt++);
 		cout << (LPCTSTR)cBuf;
 
 		sprintf(cBuf,":gs2");
 		cout << (LPCTSTR)cBuf;
 
 		while(1){
 			// {Xe[^X擾܂
 			dwRet = SVIUSB20_GetStatus2(&ulStatus);
 			if(dwRet != SVIUSB20_RET_NORMAL){
 				if(dwRet != 0xe0000079){
 					strMenu.LoadString(IDS_ERRMSG_1);
 					cout << (LPCTSTR)strMenu;
 					sprintf(cBuf," dwRet= : %08X",dwRet);
 					cout << (LPCTSTR)cBuf << endl;
 					if( bFlag ){
 						GlobalUnlock(m_hRcvMem);
 						GlobalFree(m_hRcvMem);
 					}
 					return;
 				}else{
 					sprintf(cBuf,":tmout");
 					cout << (LPCTSTR)cBuf;
 				}
 			}else{
 				sprintf(cBuf,":x%03X",ulStatus);
 				cout << (LPCTSTR)cBuf;
 				if(ulStatus == SVI_STS_FRAMEPENDING) break;
 			}
 			Sleep(3);
 		}
 
 		// j^Owb_[擾s܂
 		while(1){
 			dwRet = SVIUSB20_MonGetHeader(&MonHeader);
 			if(dwRet != SVIUSB20_RET_NORMAL){
 				if(dwRet != 0xe0000079){
 					strMenu.LoadString(IDS_ERRMSG_1);
 					cout << (LPCTSTR)strMenu;
 					sprintf(cBuf," dwRet= : %08X",dwRet);
 					cout << (LPCTSTR)cBuf << endl;
 					if( bFlag ){
 						GlobalUnlock(m_hRcvMem);
 						GlobalFree(m_hRcvMem);
 					}
 					return;
 				}else{
 					sprintf(cBuf,":tmout");
 					cout << (LPCTSTR)cBuf;
 				}
 			}else{
 				sprintf(cBuf,":mgh:");
 				cout << (LPCTSTR)cBuf;
 				break;
 			}
 			Sleep(5);
 		}
 
 		// MoCg߂܂
 		m_ulRcvLen = (MonHeader.ulMonSizeW << 1) * MonHeader.ulMonSizeH;
 #if 0
 		sprintf(cBuf,"ulStatus : %08X",MonHeader.ulStatus);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulPendingInfo : %08X",MonHeader.ulPendingInfo);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulOrgSizeW : %08X",MonHeader.ulOrgSizeW);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulOrgSizeH : %08X",MonHeader.ulOrgSizeH);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulCutout_x : %08X",MonHeader.ulCutout_x);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulCutout_y : %08X",MonHeader.ulCutout_y);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulMonSizeW : %08X",MonHeader.ulMonSizeW);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulMonSizeH : %08X",MonHeader.ulMonSizeH);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulFrameRate : %08X",MonHeader.ulFrameRate);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulLoseFrame : %08X",MonHeader.ulLoseFrame);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulOpticalAxisInfo : %08X",MonHeader.ulOpticalAxisInfo);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usCursorX : %08X",MonHeader.usCursorX);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usCursorY : %08X",MonHeader.usCursorY);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuLeftX : %08X",MonHeader.usWakuLeftX);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuLeftY : %08X",MonHeader.usWakuLeftY);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuRightX : %08X",MonHeader.usWakuRightX);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuRightY : %08X",MonHeader.usWakuRightY);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulVsyncReadLen : %08X",MonHeader.ulVsyncReadLen);
 		cout << (LPCTSTR)cBuf << endl;
 		int i;
 		for(i=0;i<(MonHeader.ulVsyncReadLen>>2);i++){
 			sprintf(cBuf,"VSYNC-DATA[%03X] : %08X",i<<2, MonHeader.ulVsyncVal[i]);
 			cout << (LPCTSTR)cBuf << endl;
 		}
 #endif
 		sprintf(cBuf,"len:x%08X",m_ulRcvLen);
 		cout << (LPCTSTR)cBuf;
 
 		m_bmHead.bfType = 0x4d42;
 		m_bmHead.bfSize = ((MonHeader.ulMonSizeW * 3) * MonHeader.ulMonSizeH) + sizeof(BM);
 		m_bmHead.bfReserved1 = 0;
 		m_bmHead.bfReserved2 = 0;
 		m_bmHead.bfOffBits = 0x36;
 		m_bmHead.biSize = 0x28;
 		m_bmHead.biWidth = MonHeader.ulMonSizeW;
 		m_bmHead.biHeight = MonHeader.ulMonSizeH;
 		m_bmHead.biPlanes = 0x1;
 		m_bmHead.biBitCount = 0x18;
 		m_bmHead.biCompression = 0x0;
 		m_bmHead.biSizeImage = (MonHeader.ulMonSizeW * 3) * MonHeader.ulMonSizeH;
 		m_bmHead.biXPelsPerMeter = 0xec4;
 		m_bmHead.biYPelsPerMeter = 0xec4;
 		m_bmHead.biClrUsed = 0x0;
 		m_bmHead.biClrImportant = 0x0;
 
 		// Mobt@߂܂
 		m_ulRcvDataSize = (((m_ulRcvLen + 63) / 64) * 64);
 
 		if( bFlag == FALSE ){
 			// Mobt@mۂ܂
 			if(NULL == (m_hRcvMem = GlobalAlloc(GHND, m_ulRcvDataSize))){
 				strMenu.LoadString(IDS_ERRMSG_1);
 				cout << (LPCTSTR)cBuf << endl;
 				strMenu.LoadString(IDS_ERRMSG_8);
 				cout << (LPCTSTR)cBuf << endl;
 				return;
 			}else{
 				sprintf(cBuf,":ga");
 				cout << (LPCTSTR)cBuf;
 			}
 
 			// Mobt@bN܂
 			if(NULL == (m_lpRcvData = GlobalLock(m_hRcvMem))){
 				strMenu.LoadString(IDS_ERRMSG_1);
 				cout << (LPCTSTR)cBuf << endl;
 				strMenu.LoadString(IDS_ERRMSG_9);
 				cout << (LPCTSTR)cBuf << endl;
 				GlobalFree(m_hRcvMem);
 				return;
 			}else{
 				sprintf(cBuf,":gl");
 				cout << (LPCTSTR)cBuf;
 			}
 
			bFlag = TRUE;
 		}
 
 		// 摜f[^M܂
 		dwRet = SVIUSB20_MonGetFrame(m_lpRcvData, m_ulRcvDataSize, &ulRetRcvLen );
 		if(dwRet != SVIUSB20_RET_NORMAL){
 			strMenu.LoadString(IDS_ERRMSG_1);
 			cout << (LPCTSTR)strMenu;
 			sprintf(cBuf," dwRet= : %08X",dwRet);
 			cout << (LPCTSTR)cBuf;
 			sprintf(cBuf," ulRetRcvLen= : %08X",ulRetRcvLen);
 			cout << (LPCTSTR)cBuf << endl;
 			GlobalUnlock(m_hRcvMem);
 			GlobalFree(m_hRcvMem);
 			return;
 		}else{
 			sprintf(cBuf,":mgf");
 			cout << (LPCTSTR)cBuf << endl;
 		}
 	}
 
 	// j^OXgbvʒm܂
 	dwRet = SVIUSB20_MonStop();
 	if(dwRet != SVIUSB20_RET_NORMAL){
 		strMenu.LoadString(IDS_ERRMSG_1);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 		GlobalUnlock(m_hRcvMem);
 		GlobalFree(m_hRcvMem);
 		return;
 	}else{
 		sprintf(cBuf,"mstop");
 		cout << (LPCTSTR)cBuf << endl;
 	}
 
 	// ct[M
 	while(1){
 
 		sprintf(cBuf,"F:x%08X",ulFCnt++);
 		cout << (LPCTSTR)cBuf;
 
 		sprintf(cBuf,":gs2");
 		cout << (LPCTSTR)cBuf;
 
 		for(j=0;j<100;j++){
 			// {Xe[^X擾܂
 				dwRet = SVIUSB20_GetStatus2(&ulStatus);
 				if(dwRet != SVIUSB20_RET_NORMAL){
 					if(dwRet != 0xe0000079){
 						strMenu.LoadString(IDS_ERRMSG_1);
 						cout << (LPCTSTR)strMenu;
 						sprintf(cBuf," dwRet= : %08X",dwRet);
 						cout << (LPCTSTR)cBuf << endl;
 						if( bFlag ){
 							GlobalUnlock(m_hRcvMem);
 							GlobalFree(m_hRcvMem);
 						}
 						return;
 					}else{
 						sprintf(cBuf,":tmout");
 						cout << (LPCTSTR)cBuf;
 					}
 				}else{
 					sprintf(cBuf,":x%03X",ulStatus);
 					cout << (LPCTSTR)cBuf;
 					if(ulStatus == SVI_STS_FRAMEPENDING) break;
 					goto MON_END;
 				}
 			Sleep(3);
 		}
 		if(j==10) break;
 
 		// j^Owb_[擾s܂
 		dwRet = SVIUSB20_MonGetHeader(&MonHeader);
 		if(dwRet != SVIUSB20_RET_NORMAL){
 			strMenu.LoadString(IDS_ERRMSG_1);
 			cout << (LPCTSTR)strMenu;
 			sprintf(cBuf," (2)dwRet= : %08X",dwRet);
 			cout << (LPCTSTR)cBuf << endl;
 			GlobalUnlock(m_hRcvMem);
 			GlobalFree(m_hRcvMem);
 			return;
 		}else{
 			sprintf(cBuf,":mgh");
 			cout << (LPCTSTR)cBuf;
 		}
 
 		// MoCg߂܂
 		m_ulRcvLen = (MonHeader.ulMonSizeW << 1) * MonHeader.ulMonSizeH;
 
 #if 0
 		sprintf(cBuf,"ulStatus : %08X",MonHeader.ulStatus);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulPendingInfo : %08X",MonHeader.ulPendingInfo);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulOrgSizeW : %08X",MonHeader.ulOrgSizeW);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulOrgSizeH : %08X",MonHeader.ulOrgSizeH);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulCutout_x : %08X",MonHeader.ulCutout_x);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulCutout_y : %08X",MonHeader.ulCutout_y);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulMonSizeW : %08X",MonHeader.ulMonSizeW);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulMonSizeH : %08X",MonHeader.ulMonSizeH);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulFrameRate : %08X",MonHeader.ulFrameRate);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulLoseFrame : %08X",MonHeader.ulLoseFrame);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulOpticalAxisInfo : %08X",MonHeader.ulOpticalAxisInfo);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usCursorX : %08X",MonHeader.usCursorX);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usCursorY : %08X",MonHeader.usCursorY);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuLeftX : %08X",MonHeader.usWakuLeftX);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuLeftY : %08X",MonHeader.usWakuLeftY);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuRightX : %08X",MonHeader.usWakuRightX);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"usWakuRightY : %08X",MonHeader.usWakuRightY);
 		cout << (LPCTSTR)cBuf << endl;
 		sprintf(cBuf,"ulVsyncReadLen : %08X",MonHeader.ulVsyncReadLen);
 		cout << (LPCTSTR)cBuf << endl;
 		for(i=0;i<(MonHeader.ulVsyncReadLen>>2);i++){
 			sprintf(cBuf,"VSYNC-DATA[%03X] : %08X",i<<2, MonHeader.ulVsyncVal[i]);
 			cout << (LPCTSTR)cBuf << endl;
 		}
 #endif
 		sprintf(cBuf,":len:x%08X",m_ulRcvLen);
 		cout << (LPCTSTR)cBuf;
 
 		m_bmHead.bfType = 0x4d42;
 		m_bmHead.bfSize = ((MonHeader.ulMonSizeW * 3) * MonHeader.ulMonSizeH) + sizeof(BM);
 		m_bmHead.bfReserved1 = 0;
 		m_bmHead.bfReserved2 = 0;
 		m_bmHead.bfOffBits = 0x36;
 		m_bmHead.biSize = 0x28;
 		m_bmHead.biWidth = MonHeader.ulMonSizeW;
 		m_bmHead.biHeight = MonHeader.ulMonSizeH;
 		m_bmHead.biPlanes = 0x1;
 		m_bmHead.biBitCount = 0x18;
 		m_bmHead.biCompression = 0x0;
 		m_bmHead.biSizeImage = (MonHeader.ulMonSizeW * 3) * MonHeader.ulMonSizeH;
 		m_bmHead.biXPelsPerMeter = 0xec4;
 		m_bmHead.biYPelsPerMeter = 0xec4;
 		m_bmHead.biClrUsed = 0x0;
 		m_bmHead.biClrImportant = 0x0;
 
 		// Mobt@߂܂
 		m_ulRcvDataSize = (((m_ulRcvLen + 63) / 64) * 64);
 
 		// 摜f[^M܂
 		dwRet = SVIUSB20_MonGetFrame(m_lpRcvData, m_ulRcvDataSize, &ulRetRcvLen );
 		if(dwRet != SVIUSB20_RET_NORMAL){
 			strMenu.LoadString(IDS_ERRMSG_1);
 			cout << (LPCTSTR)strMenu;
 			sprintf(cBuf," (3)dwRet= : %08X",dwRet);
 			cout << (LPCTSTR)cBuf;
 			sprintf(cBuf," ulRetRcvLen= : %08X",ulRetRcvLen);
 			cout << (LPCTSTR)cBuf << endl;
 			GlobalUnlock(m_hRcvMem);
 			GlobalFree(m_hRcvMem);
 			return;
 		}else{
 			sprintf(cBuf,":mgf");
 			cout << (LPCTSTR)cBuf << endl;
 		}
 	}
 MON_END:
 	GlobalUnlock(m_hRcvMem);
 	GlobalFree(m_hRcvMem);
 
mon_close:

	// foCXhCoN[Y
 	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_REC)) != SVIUSB20_RET_NORMAL) {
 		strMenu.LoadString(IDS_ERRMSG_3);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 	}
 
 }

 void Cui::sdk_rec()
 {
  	CString strMenu;
  	char cBuf[32];
  	DWORD dwRet;
  	RECORD_PARAM RecParam;
  	REC_HEADER RecHeader;
  	ULONG ulRetRcvLen,ulStatus;
  	BOOL bFlag = FALSE;
  	int i,j;
	GET_STATUS GetStatus;
  	CFile mFile;

 	// foCXhCoI[v
 	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_REC)) != SVIUSB20_RET_NORMAL) {
 		strMenu.LoadString(IDS_ERRMSG_2);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 		return;
 	}

 	// ڑ`FbN
	for(j=0;j<3;j++){

		// SVI{[hZbg
 		if((dwRet=SVIUSB20_DeviceReset()) != SVIUSB20_RET_NORMAL) {
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
			goto rec_close;
		}

		// Xe[^X擾s܂
 		if((dwRet=SVIUSB20_GetStatus(&GetStatus)) != SVIUSB20_RET_NORMAL) {
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
			goto rec_close;
		}
		sprintf(cBuf,"ulBasicStatus : %08X",GetStatus.ulBasicStatus);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulHWVersion : %08X",GetStatus.ulHWVersion);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulFWVersion : %08X",GetStatus.ulFWVersion);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulOPStatus : %08X",GetStatus.ulOPStatus);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulStartupStatus : %08X",GetStatus.ulStartupStatus);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulOrgSizeW : %08X",GetStatus.ulOrgSizeW);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulOrgSizeH : %08X",GetStatus.ulOrgSizeH);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutout_x : %08X",GetStatus.ulCutout_x);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutout_y : %08X",GetStatus.ulCutout_y);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutSizeW : %08X",GetStatus.ulCutSizeW);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCutSizeH : %08X",GetStatus.ulCutSizeH);
		cout << (LPCTSTR)cBuf << endl;
		sprintf(cBuf,"ulCamStatus : %08X",GetStatus.ulCamStatus);
		cout << (LPCTSTR)cBuf << endl;

		if( GetStatus.ulBasicStatus == SVI_STS_SUCCESS ) break;
		if( j == 2) goto rec_close;
	}
	
  	strMenu.LoadString(IDS_MENU_RPARAM_1);
  	cout << (LPCTSTR)strMenu;
  	cin >> cBuf;
  	sscanf(cBuf,"%x",&RecParam.ulFrameCount);
  
  	strMenu.LoadString(IDS_MENU_RPARAM_2);
  	cout << (LPCTSTR)strMenu;
  	cin >> cBuf;
  	sscanf(cBuf,"%x",&RecParam.ulBufferCount);
  
  	strMenu.LoadString(IDS_MENU_RPARAM_3);
  	cout << (LPCTSTR)strMenu;
  	cin >> cBuf;
  	sscanf(cBuf,"%x",&RecParam.ulRecMode);
  
  	// R[fBOX^[gʒm܂
  	dwRet = SVIUSB20_RecStart(&RecParam);
  	if(dwRet != SVIUSB20_RET_NORMAL){
  		strMenu.LoadString(IDS_ERRMSG_1);
  		cout << (LPCTSTR)strMenu;
  		sprintf(cBuf," dwRet= : %08X",dwRet);
  		cout << (LPCTSTR)cBuf << endl;
  		goto rec_close;
  	}
  
  	while(1){
  		// {Xe[^X擾܂
  		dwRet = SVIUSB20_GetStatus2(&ulStatus);
  		if(dwRet != SVIUSB20_RET_NORMAL){
  			strMenu.LoadString(IDS_ERRMSG_1);
  			cout << (LPCTSTR)strMenu;
  			sprintf(cBuf," dwRet= : %08X",dwRet);
  			cout << (LPCTSTR)cBuf << endl;
	  		goto rec_close;
  		}
  		sprintf(cBuf,"ulStatus : %08X",ulStatus);
  		cout << (LPCTSTR)cBuf << endl;
  		if(ulStatus == SVI_STS_FRAMEPENDING) break;
  		Sleep(3);
  	}
  
  	// R[fBOwb_[擾s܂
  	dwRet = SVIUSB20_RecGetHeader(&RecHeader);
  	if(dwRet != SVIUSB20_RET_NORMAL){
  		strMenu.LoadString(IDS_ERRMSG_1);
  		cout << (LPCTSTR)strMenu;
  		sprintf(cBuf," dwRet= : %08X",dwRet);
  		cout << (LPCTSTR)cBuf << endl;
  		goto rec_close;
  	}
  	sprintf(cBuf,"ulStatus : %08X",RecHeader.ulStatus);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"ulPendingInfo : %08X",RecHeader.ulPendingInfo);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"ubFirmVersion : %02X",RecHeader.ubFirmVersion);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"ubHardVersion : %02X",RecHeader.ubHardVersion);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"usNumChannel : %04X",RecHeader.usNumChannel);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"ubCompFlag : %02X",RecHeader.ubCompFlag);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"ulNumScan : %08X",RecHeader.ulNumScan);
  	cout << (LPCTSTR)cBuf << endl;
  	sprintf(cBuf,"usDataWidth : %04X",RecHeader.usDataWidth);
  	cout << (LPCTSTR)cBuf << endl;
  	m_ulRcvLen = RecHeader.ulNumScan;
  
  	// Mobt@߂܂
  	m_ulRcvDataSize = (((m_ulRcvLen + 63) / 64) * 64);
  
  	// Mobt@mۂ܂
  	if(NULL == (m_hRcvMem = GlobalAlloc(GHND, m_ulRcvDataSize))){
  		strMenu.LoadString(IDS_ERRMSG_1);
  		cout << (LPCTSTR)cBuf << endl;
  		strMenu.LoadString(IDS_ERRMSG_8);
  		cout << (LPCTSTR)cBuf << endl;
  		goto rec_close;
  	}else{
  		strMenu.LoadString(IDS_ERRMSG_0);
  		cout << (LPCTSTR)strMenu << endl;
  	}
  
  	// Mobt@bN܂
  	if(NULL == (m_lpRcvData = GlobalLock(m_hRcvMem))){
  		strMenu.LoadString(IDS_ERRMSG_1);
  		cout << (LPCTSTR)cBuf << endl;
  		strMenu.LoadString(IDS_ERRMSG_9);
  		cout << (LPCTSTR)cBuf << endl;
  		GlobalFree(m_hRcvMem);
  		goto rec_close;
  	}else{
  		strMenu.LoadString(IDS_ERRMSG_0);
  		cout << (LPCTSTR)strMenu << endl;
  	}
  
  	bFlag = TRUE;
  	
  	// R[fBOf[^M܂
  	dwRet = SVIUSB20_RecGetFrames(m_lpRcvData, m_ulRcvLen, &ulRetRcvLen);
  	if(dwRet != SVIUSB20_RET_NORMAL){
  		strMenu.LoadString(IDS_ERRMSG_1);
  		cout << (LPCTSTR)strMenu;
  		sprintf(cBuf," dwRet= : %08X",dwRet);
  		cout << (LPCTSTR)cBuf << endl;
  		GlobalUnlock(m_hRcvMem);
  		GlobalFree(m_hRcvMem);
  		goto rec_close;
  	}else{
  		strMenu.LoadString(IDS_ERRMSG_0);
  		cout << (LPCTSTR)strMenu << endl;
  	}
  
  	// R[fBOXgbvʒm܂
  	dwRet = SVIUSB20_RecStop();
  	if(dwRet != SVIUSB20_RET_NORMAL){
  		strMenu.LoadString(IDS_ERRMSG_1);
  		cout << (LPCTSTR)strMenu;
  		sprintf(cBuf," dwRet= : %08X",dwRet);
  		cout << (LPCTSTR)cBuf << endl;
  		GlobalUnlock(m_hRcvMem);
  		GlobalFree(m_hRcvMem);
  		goto rec_close;
  	}else{
  		strMenu.LoadString(IDS_ERRMSG_0);
  		cout << (LPCTSTR)strMenu << endl;
  	}
  
  	// t@C͂܂
  	strMenu.LoadString(IDS_MENU_SPARAM_7);
  	cout << (LPCTSTR)strMenu;
  	cin >> cBuf;
  
  	// t@CI[v܂
  	if( !mFile.Open((LPCTSTR)cBuf,CFile::modeCreate | CFile::modeWrite) ){
  		strMenu.LoadString(IDS_ERRMSG_5);
  		cout << (LPCTSTR)strMenu << endl;
  		GlobalUnlock(m_hRcvMem);
  		GlobalFree(m_hRcvMem);
  		goto rec_close;
  	}
  
  	// t@C֏o͌At@CN[Y܂
  	sprintf(cBuf,"SVI-Rec V1");	mFile.Write( cBuf, 10 ); // ID
  	mFile.Write( &RecHeader.ubFirmVersion, 11 ); // REC_HEADER
  	for(i=0;i<32;i++) cBuf[i] = 0x0;
  	mFile.Write( cBuf, 14 ); // channel_order,ad_range,scan_rate,num_of_channel_range
  	sprintf(cBuf,"04/01/2612:34:56789"); mFile.Write( cBuf, 19 ); // start_date,time,milisec
  	for(i=0;i<32;i++) cBuf[i] = 0x0;
  	mFile.Write( cBuf, 6 ); // reserve,offset
  	mFile.Write( m_lpRcvData, ulRetRcvLen );
  	mFile.Close();

rec_close:
	
 	// foCXhCoN[Y
 	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_REC)) != SVIUSB20_RET_NORMAL) {
 		strMenu.LoadString(IDS_ERRMSG_3);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 	}
  
 }

 void Cui::sdk_i2c_write()
 {
 	CString strMenu;
 	char cBuf[32];
 	DWORD dwRet;
 	ULONG ulSendData[32];
 	ULONG ulSlaveAdr;
 	ULONG ulSubAdr;
 	int iSendCnt, i;
 	UCHAR ucBuf[32];
 
 	// foCXhCoI[v
 	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
 		strMenu.LoadString(IDS_ERRMSG_2);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
 		return;
 	}
 
 	// X[uAhX擾
 	strMenu.LoadString(IDS_MENU_WREG1);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%x",&ulSlaveAdr);
 
 	// TuAhX擾
 	strMenu.LoadString(IDS_MENU_WREG2);
 	cout << (LPCTSTR)strMenu;
 	cin >> cBuf;
 	sscanf(cBuf,"%x",&ulSubAdr);
 
 	for(iSendCnt=0;iSendCnt<32;iSendCnt++){
 		// ݃f[^擾
 		strMenu.LoadString(IDS_MENU_WREG3);
 		cout << (LPCTSTR)strMenu;
 		cin >> cBuf;
 		if(cBuf[0] == '/'){
 			break;
 		}
 		sscanf(cBuf,"%x",&ulSendData[iSendCnt]);
 	}

	for(i=0;i<iSendCnt;i++){
		ucBuf[i] = (UCHAR)ulSendData[i];
	}

	// X[uAhXATuAhXubNCg܂
	dwRet = SVIUSB20_I2COneBlockWrite (ulSlaveAdr,iSendCnt+1,0,(PUCHAR)&ucBuf[0]);
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	 	// I2CXgbvRfBVʒm܂
 		dwRet = SVIUSB20_I2CStop();
	 	if(dwRet != SVIUSB20_RET_NORMAL){
 			strMenu.LoadString(IDS_ERRMSG_1);
 			cout << (LPCTSTR)strMenu;
	 		sprintf(cBuf," dwRet= : %08X",dwRet);
 			cout << (LPCTSTR)cBuf << endl;
		}
 	}
 
 	// foCXhCoN[Y
 	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
 		strMenu.LoadString(IDS_ERRMSG_3);
 		cout << (LPCTSTR)strMenu;
 		sprintf(cBuf," dwRet= : %08X",dwRet);
 		cout << (LPCTSTR)cBuf << endl;
	}
}

void Cui::sdk_i2c_read()
{
	CString strMenu;
	char cBuf[32],dBuf[32];
	DWORD dwRet;
	ULONG ulSlaveAdr;
	ULONG ulRcvCnt;
	int i;

	// foCXhCoI[v
	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_2);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}

	// X[uAhX擾
	strMenu.LoadString(IDS_MENU_RREG1);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&ulSlaveAdr);

	// TuAhX擾
	strMenu.LoadString(IDS_MENU_RREG2);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&cBuf[4]);

	// ǂݍ݃oCg擾
	strMenu.LoadString(IDS_MENU_RREG4);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&ulRcvCnt);

		// X[uAhXATuAhXubNCg܂
		dwRet = SVIUSB20_I2COneBlockWrite (ulSlaveAdr,1,0x80000000,(PUCHAR)&cBuf[4]);
		if(dwRet != SVIUSB20_RET_NORMAL){
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
	 		// I2CXgbvRfBVʒm܂
 			dwRet = SVIUSB20_I2CStop();
	 		if(dwRet != SVIUSB20_RET_NORMAL){
 				strMenu.LoadString(IDS_ERRMSG_1);
 				cout << (LPCTSTR)strMenu;
	 			sprintf(cBuf," dwRet= : %08X",dwRet);
 				cout << (LPCTSTR)cBuf << endl;
			}
		}else{
			// X[uAhXCgAf[^ubN[h܂
			dwRet = SVIUSB20_I2COneBlockRead (ulSlaveAdr,ulRcvCnt,0x80000000,(PUCHAR)cBuf);
			if(dwRet != SVIUSB20_RET_NORMAL){
				strMenu.LoadString(IDS_ERRMSG_1);
				cout << (LPCTSTR)strMenu;
				sprintf(cBuf," dwRet= : %08X",dwRet);
				cout << (LPCTSTR)cBuf << endl;
				// I2CXgbvRfBVʒm܂
 				dwRet = SVIUSB20_I2CStop();
			 	if(dwRet != SVIUSB20_RET_NORMAL){
 					strMenu.LoadString(IDS_ERRMSG_1);
 					cout << (LPCTSTR)strMenu;
	 				sprintf(cBuf," dwRet= : %08X",dwRet);
 					cout << (LPCTSTR)cBuf << endl;
				}
				goto i2cr_close;
			}

			for(i=0;i<ulRcvCnt;i++){
				sprintf(dBuf,"ǂݍ݃f[^(hex) : %02X\n",cBuf[i]);
				cout << (LPCTSTR)dBuf << endl;
			}
		}

i2cr_close:
	// foCXhCoN[Y
	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_3);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}
}

void Cui::sdk_setfile1()
{
	CString strMenu;
	char cBuf[32];
	char cFilename[80];
	DWORD dwRet;
	ULONG ulSendData[16];
	ULONG ulSlaveAdr;
	int i,j,iSendDataCnt;
	FILE *fp;
	UCHAR ucSendBuf[4*16];

	// foCXhCoI[v
	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_2);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}

	// ݒt@C擾
	strMenu.LoadString(IDS_MENU_SPARAM_7);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%s",cFilename);

	// X[uAhX擾
	strMenu.LoadString(IDS_MENU_WREG1);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&ulSlaveAdr);

	// ݒt@C[Ղ
	fp = fopen(cFilename,"r");
	if(fp == NULL){
		sprintf(cBuf,"ݒt@CI[vG[ : %s",cFilename);
		cout << (LPCTSTR)cBuf << endl;
		goto svi_sclose2;
	}

	// ݒt@Cǂݍ1sTuAhXƏ݃f[^
	// 擾AJփCg
	while(1){

		// 1sǂݍ݂܂
		if(fgets(cFilename,80,fp)==NULL) break;
		if(cFilename[0] == '#') continue;
		if(cFilename[0] == ';') continue;
		for(iSendDataCnt=0,i=0;;){
			// ݃f[^擾܂
			for(j=i;i<80;i++){
				if(cFilename[i] == ',') break;
				if(cFilename[i] == '\r') break;
				if(cFilename[i] == '\n') break;
				if(cFilename[i] == '\t') break;
				if(cFilename[i] == ' ') break;
				if(cFilename[i] == ';') break;
				if(cFilename[i] == '\0') break;
			}
			cFilename[i++] = '\0';
			sscanf(&cFilename[j],"%x",&ulSendData[iSendDataCnt++]);
			if(cFilename[i] == '\r') break;
			if(cFilename[i] == '\n') break;
			if(cFilename[i] == '\t') break;
			if(cFilename[i] == ' ') break;
			if(cFilename[i] == ';') break;
			if(cFilename[i] == '\0') break;
		}

		for(i=0;i<iSendDataCnt;i++){
			ucSendBuf[i] = (UCHAR)ulSendData[i];
		}

		dwRet = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,iSendDataCnt,0,ucSendBuf);
		if(dwRet != SVIUSB20_RET_NORMAL){
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
			// I2CXgbvRfBVʒm܂
			dwRet = SVIUSB20_I2CStop();
			if(dwRet != SVIUSB20_RET_NORMAL){
				strMenu.LoadString(IDS_ERRMSG_1);
				cout << (LPCTSTR)strMenu;
				sprintf(cBuf," dwRet(4)= : %08X",dwRet);
				cout << (LPCTSTR)cBuf << endl;
			}
			goto svi_sclose;
		}

	}

svi_sclose:
	// ݒt@CN[Y
	fclose(fp);
svi_sclose2:

	// foCXhCoN[Y
	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_3);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}
}

void Cui::sdk_setfile2()
{
	CString strMenu;
	char cBuf[32];
	char cFilename[80];
	DWORD dwRet;
	ULONG ulSendData[16];
	ULONG ulSlaveAdr;
	int i,j,iSendDataCnt;
	FILE *fp;
	UCHAR ucSendBuf[4*16];

	ulSendData[0] = 0;

	// foCXhCoI[v
	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_2);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}

	// ݒt@C擾
	strMenu.LoadString(IDS_MENU_SPARAM_7);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%s",cFilename);

	// X[uAhX擾
	strMenu.LoadString(IDS_MENU_WREG1);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%x",&ulSlaveAdr);

	// ݒt@C[Ղ
	fp = fopen(cFilename,"r");
	if(fp == NULL){
		sprintf(cBuf,"ݒt@CI[vG[ : %s",cFilename);
		cout << (LPCTSTR)cBuf << endl;
		goto svi_sclose2;
	}

	// ݒt@Cǂݍ1sTuAhXƏ݃f[^
	// 擾AJփCg
	while(1){

		// 1sǂݍ݂܂
		if(fgets(cFilename,80,fp)==NULL) break;
		if(cFilename[0] == '#' ) continue;
		if(cFilename[0] == ';' ) continue;
		if(cFilename[0] == '\r') continue;
		if(cFilename[0] == '\n') continue;
		for(iSendDataCnt=0,i=0;;){
			// ݃f[^擾܂
			for(j=i;i<80;i++){
				if(cFilename[i] == ';') break;
				if(cFilename[i] == '#') break;
				if(cFilename[i] == '\r') break;
				if(cFilename[i] == '\n') break;
				if(cFilename[i] == '\0') break;
				if(cFilename[i] == '\t') break;
				if(cFilename[i] == ' ') break;
			}
			cFilename[i++] = '\0';
			if(ulSendData[0] == 0xffffffff){
				sscanf(&cFilename[j],"%d",&ulSendData[iSendDataCnt++]);
			}else{
				sscanf(&cFilename[j],"%x",&ulSendData[iSendDataCnt++]);
			}
			if(cFilename[j] == 'w' && cFilename[j+1] == 't') ulSendData[0] = 0xffffffff;
			if(cFilename[i] == ';') break;
			if(cFilename[i] == '#') break;
			if(cFilename[i] == '\r') break;
			if(cFilename[i] == '\n') break;
			if(cFilename[i] == '\t') break;
			if(cFilename[i] == ' ') break;
			if(cFilename[i] == '\0') break;
		}

		if(ulSendData[0] == 0xffffffff){
			Sleep(ulSendData[1]);
			continue;
		}else{
			for(i=0;i<iSendDataCnt;i++){
				ucSendBuf[i] = (UCHAR)ulSendData[i];
			}
		}
		dwRet = SVIUSB20_I2COneBlockWrite(ulSlaveAdr,iSendDataCnt,0,ucSendBuf);
		if(dwRet != SVIUSB20_RET_NORMAL){
			strMenu.LoadString(IDS_ERRMSG_1);
			cout << (LPCTSTR)strMenu;
			sprintf(cBuf," dwRet= : %08X",dwRet);
			cout << (LPCTSTR)cBuf << endl;
			// I2CXgbvRfBVʒm܂
			dwRet = SVIUSB20_I2CStop();
			if(dwRet != SVIUSB20_RET_NORMAL){
				strMenu.LoadString(IDS_ERRMSG_1);
				cout << (LPCTSTR)strMenu;
				sprintf(cBuf," dwRet(4)= : %08X",dwRet);
				cout << (LPCTSTR)cBuf << endl;
			}
			goto svi_sclose;
		}

	}

svi_sclose:
	// ݒt@CN[Y
	fclose(fp);
svi_sclose2:

	// foCXhCoN[Y
	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_3);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}
}

void Cui::sdk_gpioacc()
{
	CString strMenu;
	char cBuf[32],dBuf[32];
	DWORD dwRet;
	ULONG ulMode;
	ULONG ulBitMask;
	ULONG ulData;

	// foCXhCoI[v
	if((dwRet=SVIUSB20_Open(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_2);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		return;
	}

	// In(0)/Out(1) ? 
	strMenu.LoadString(IDS_MENU_GPARAM_1);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%d",&ulMode);

	// Bit mask (bit0-2) ? 
	strMenu.LoadString(IDS_MENU_GPARAM_2);
	cout << (LPCTSTR)strMenu;
	cin >> cBuf;
	sscanf(cBuf,"%d",&ulBitMask);

	if(ulMode == 1){
		// output data ? 
		strMenu.LoadString(IDS_MENU_GPARAM_3);
		cout << (LPCTSTR)strMenu;
		cin >> cBuf;
		sscanf(cBuf,"%x",&ulData);
	}

	// GPIOANZX܂
	dwRet = SVIUSB20_GpioAcc(ulMode, ulBitMask, &ulData, 0);
	if(dwRet != SVIUSB20_RET_NORMAL){
		strMenu.LoadString(IDS_ERRMSG_1);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
		goto acc_close;
	}

	if(ulMode == 0){
		sprintf(dBuf,"Input data (HEX) : %02X\n",ulData);
		cout << (LPCTSTR)dBuf << endl;
	}

	sprintf(dBuf,"OK\n");
	cout << (LPCTSTR)dBuf << endl;

acc_close:
	// foCXhCoN[Y
	if((dwRet=SVIUSB20_Close(SVIUSB20_APP_WHO_CTL)) != SVIUSB20_RET_NORMAL) {
		strMenu.LoadString(IDS_ERRMSG_3);
		cout << (LPCTSTR)strMenu;
		sprintf(cBuf," dwRet= : %08X",dwRet);
		cout << (LPCTSTR)cBuf << endl;
	}
}

void Cui::sdk_menu(BOOL bMenuFlag)
 {
 	CString strMenu;
 
 	// j[\܂
 	// bMenuFlagTRUE̎Sj[\܂
 	if( bMenuFlag == TRUE ){
 		strMenu.LoadString(IDS_MENU1);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU3);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU4);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU9);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU7);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU2);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU6);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU8);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU11);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU5);		cout << (LPCTSTR)strMenu << endl;
 		strMenu.LoadString(IDS_MENU1);		cout << (LPCTSTR)strMenu << endl;
 	}
 
 	// vvg\܂
 	strMenu.LoadString(IDS_PROMPT);
 	cout << (LPCTSTR)strMenu;
 }

DWORD Cui::sdk_keyin()
{
	char cBuf[10];
	DWORD dwCno;
	CString strMenu;

	// L[CăGR[\܂
	cin >> cBuf;
	if(cBuf[1] != NULL) cBuf[0] = 0x0;

	// R}hfR[h܂
	switch( cBuf[0] )
	{
	case	'a':	// j^O摜擾
	case	'A':
		dwCno = SDK_CMD_MON;
		break;
	case	'b':	// R[fBO摜擾
	case	'B':
		dwCno = SDK_CMD_REC;
		break;
	case	'c':	// I2CR}hM
	case	'C':
		dwCno = SDK_CMD_I2CWRITE;
		break;
	case	'd':	// I2CR}hM
	case	'D':
		dwCno = SDK_CMD_I2CREAD;
		break;
	case	'e':	// ݒt@CMiJ}؂j
	case	'E':
		dwCno = SDK_CMD_SETFILE1;
		break;
	case	'f':	// ݒt@CMiXy[X؂j
	case	'F':
		dwCno = SDK_CMD_SETFILE2;
		break;
	case	'g':	// n[hEFAݒ
	case	'G':
		dwCno = SDK_CMD_SETPARAM;
		break;
	case	'h':	// GPIOANZX
	case	'H':
		dwCno = SDK_CMD_GPIOACC;
		break;
	case	'q':	// I
	case	'Q':
		dwCno = SDK_CMD_QUIT;
		break;
	default:
		strMenu.LoadString(IDS_ERRMSG_4);
		cout << (LPCTSTR)strMenu << endl;
		dwCno = 0;
	}
	return dwCno;
}
